% Solution of the Matlab Exercise, Sheet 1
% (see http://syscop.de/teaching/2016/systemtheorie-und-regelungstechnik-1)

% AUTHOR: Florian Messerer
% Systems control and optimization laboratory, 
% Department of Microsystems Engineering (IMTEK),
% University of Freiburg
% 
% File Created: 16.05.2016

clear all % clear workspace
%% Task 1

% 1a)
x = [-2;3];
y = [3 7 -3];
A = [3 1 6; 5 -2 4];

% 1b)
z = 0:.1:1;
z2 = linspace(0,1,11);

% 1c)
a = A(:,1);
b = A(2,2:3);

% 1d)
B = ones(3,4);

% 1e)
C = zeros(size(B));

%% Task 2

% 2a)
D = A'*A; % or D = transpose(A)*A;
% careful: If A contains complex numbers A' also gives the complex conjugate
% of them. Use tranpose() to be safe.

% 2b)
A(:,end) = A(:,end) + x;

% 2c)
A = [A;y];

% 2d)
square_result_1 = A^2;
square_result_2 = A.^2;

% 2e)
c = x'*a;
% or: c = dot(x,a);

%% Task 3

n = 5;
d = zeros(n,1); % preallocation. not necessary but recommended by matlab. doesn't really matter here
for i = 1:n
    d(i) = 3*i^2+1;
end

%% Task 4

close all % close all open figures
% 4a)
% see fct_f.m

% 4b)
x = -5:.1:5;

figure(1)
plot(x,fct_f(x))
xlabel('x')
ylabel('f(x)')
title('Plot von f(x)')

% 4c)
g = @(x) 3*sqrt(10*x.^2);

% 4d)
h = -3*x.^2-2;

% 4e)
figure(2)
% plot(x,fct_f(x), x, g(x), x,h) % or plot(x,[fct_f(x);g(x);h])
legend('f','g','h')
xlabel('x')
